#!/bin/bash

delete_ssl() {
  local user="${1}"
  local friendlyname="${2}"
  local id="${3}"
 
  uapi --output=jsonpretty --user="${user}" SSL delete_cert friendly_name="${friendlyname}" id="${id}"
}

#搜尋幾天內的日誌，預設是3天內
 search_range=3



# 防呆判斷
if [ -e /usr/bin/jetbackup ]; then
   echo ''
   echo "此主機JetBackup版本為4版，請在jetbackup5 主機上執行"
   echo ''
   exit
fi


#建立cPanel 帳號之陣列
user_array=($(cat /etc/trueuserdomains |awk '{print $2}'))
id_array=($(find /usr/local/jetapps/var/log/jetbackup5/queue -type f -name "*.log" -mtime -"${search_range}" -exec cat {} \; | grep 'Failed fetching certificate id' |awk -F 'certificate id ' '{print $2}' |awk -F . '{print $1}' |sort |uniq |sort))

if [ -z "${id_array[*]}" ]; then
    echo ""
    echo "沒有錯誤的 certificate id ，故不需執行"
    echo ""
    exit
fi  


count=0

for account in ${user_array[*]}
do        
    user_list_ssl_array=$(whmapi1 --output=jsonpretty listcrts user=${account})

	# 使用jq 檢查每個證書的 issuer.organizationName
	crt_count=$(echo "$user_list_ssl_array" | jq '.data.crt | length')


	for ((i=0; i<crt_count; i++)); 
	do
		crt_id=$(echo "${user_list_ssl_array}" | jq -r  ".data.crt[$i].id")
		crt_domain=$(echo "${user_list_ssl_array}" | jq ".data.crt[$i].domain")
		crt_name=$(echo "${user_list_ssl_array}" | jq -r  ".data.crt[$i].\"issuer.organizationName\"")
		crt_friendlyname=$(echo "${user_list_ssl_array}" | jq -r  ".data.crt[$i].friendly_name")
		issuer_name=$(echo "${user_list_ssl_array}" | jq -r  ".data.crt[$i].\"issuer.organizationName\"")

	echo ""
		for id in ${id_array[*]}
		do
			 if [[ "$crt_name" =~ "Let's Encrypt" ]]; then
    	 			 if [[ "${id}" =~ "${crt_id}" ]]; then
			           echo "帳號:" ${account} $'\n'"網域:" $crt_domain  $'\n'"憑證:" ${crt_name}  $'\n'"憑證ID:" ${crt_id} $'\n'"憑證別稱:" ${crt_friendlyname} >> /root/ssl_id_check_result.txt 
					   echo "" >> /root/ssl_id_check_result.txt
					   count=$((${count} +1))
					   echo "第 "$count " 筆" >> /root/ssl_id_check_result.txt
					   echo ""
					   echo ""
					   echo ""
    	       		   delete_ssl "${account}" "${crt_friendlyname}" "${crt_id}"
    	  			 fi
    			     echo ""
 			 fi
		done
	done
done

